#include "camera.h"
#include "timer.h"

float ScreenWidth=1.0f,ScreenHeight=1.0f;
//defaultaas veertiibas ne 0.0f, lai nenotiktu daliishana ar 0


CCamera::CCamera()
{
    Position.x=0.0f;
    Position.y=-30.0f; //kamera saak 30 vieniibas gaisaa
    Position.z=0.0f;
    
    Rotation.x=15.0f;  //skats pagriozts 15 graadus uz leju
    Rotation.y=135.0f; //un 135 graadus pa labi
    Rotation.z=0.0f;
}



void CCamera::ApplyRotation()
{
    glRotatef(Rotation.x,1.0f,0.0f,0.0f);//no saakuma pagriezjam skatu uz augshu/leju
    glRotatef(Rotation.y,0.0f,1.0f,0.0f);//peec tam pa labi/kreisi
}  


  
void CCamera::ApplyPosition()
{
    glTranslatef(Position.x,Position.y,Position.z);//nobiidam kameru savaa poziicijaa
}


void CCamera::Controls()
{
    float Time=Timer.GetLastFrameTime();//kaada sekundes dalja pagaajusi peedeejaa kadra laikaa?
    
    Matrix4x4 Modelview;
    glGetFloatv(GL_MODELVIEW_MATRIX,Modelview.M);//panjemam modelview matricu no OGL
    //matricas elementos 2,6,10 - glabaajas kameras vektors "uz priekshu"
    //elementos 0,4,8 - "pa kreisi"
    //elementos 1,5,9 - "uz augshu"
    
    if(Keys[SDLK_UP]) //ja ir nospiesta poga uz augshuu
    {                 //pieskaitam pie poziicijas vektoru "uz priekshu"
        Position.x+=270.0f*Time*Modelview.M[2];//pareizinaatu ar aatrumu (270 vieniibas/sec)
        Position.y+=270.0f*Time*Modelview.M[6];//un arii ar pagaajusho sekundes dalju
        Position.z+=270.0f*Time*Modelview.M[10];
    }
    if(Keys[SDLK_DOWN]) //ja ir nospiesta poga uz leju
    {                   //atnjemam no poziicijas vektoru "uz priekshu"
        Position.x-=270.0f*Time*Modelview.M[2];//pareizinaatu ar aatrumu (270 vieniibas/sec)
        Position.y-=270.0f*Time*Modelview.M[6];//un arii ar pagaajusho sekundes dalju
        Position.z-=270.0f*Time*Modelview.M[10];
    }
    if(Keys[SDLK_LEFT]) //ja ir nospiesta poga pa kreisi
    {                   //pieskaitam pie poziicijas vektoru "pa kreisi"
        Position.x+=270.0f*Time*Modelview.M[0];//pareizinaatu ar aatrumu (270 vieniibas/sec)
        Position.y+=270.0f*Time*Modelview.M[4];//un arii ar pagaajusho sekundes dalju
        Position.z+=270.0f*Time*Modelview.M[8];
    }
    if(Keys[SDLK_RIGHT]) //ja ir nospiesta poga pa labi
    {                    //atnjemam no poziicijas vektoru "pa kreisi"
        Position.x-=270.0f*Time*Modelview.M[0];//pareizinaatu ar aatrumu (270 vieniibas/sec)
        Position.y-=270.0f*Time*Modelview.M[4];//un arii ar pagaajusho sekundes dalju
        Position.z-=270.0f*Time*Modelview.M[8];
    }
    
    static bool WasPushed=false; //mainiigais, kuraa glabaasim to, vai ieprieksheejaa
                                 //kadraa bija nospiesta peles kreisaa poga
    static int last_cursorx,last_cursory; //peedeejaa kadra kursora poziicijas
    
    int cursorx,cursory; //shii kadra kursora poziicijas
    unsigned char ButtonState; //mainiigais, kuraa glabaasies peles pogu staavoklis
    ButtonState=SDL_GetMouseState(&cursorx,&cursory); //nododam pointerus, kur ierakstiit
                    //peles poziiciju, bet ButtonState sanjem visu peles pogu staavokljus
    if(ButtonState & SDL_BUTTON(1)) //ja ir nospiesta kreisaa (nr 1) peles poga
    {
        if(WasPushed) //ja ieprieksheejaa kadraa arii bija nospiesta poga
        {
            float xdif=((float)last_cursorx-cursorx); //ieguustam starpiibu starp pagaajushaa
            float ydif=((float)last_cursory-cursory); //un shii kadra peles kursora poziicijaam
            Rotation.y-=xdif*0.25f; //izmainam kameras rotaaciju attieciigi peles kustiibai
            Rotation.x-=ydif*0.25f; //0.25f - peles "juutigums"
            SDL_WarpMouse(last_cursorx,last_cursory); //novietojam peli atpakalj saakuma poziicijaa
                    //lai taa netiktu izkustinaata aaraa no muusu loga, kameer tai jaavada kamera
        } else { //ja ieprieksheejaa kadraa poga nebija nospiesta
            WasPushed=true; //pierakstam, ka shajaa kadraa taa bija nospiesta
            last_cursorx=cursorx; //un pierakstam peles kursora poziicijas lai
            last_cursory=cursory; //naakamos kadros zinaatu, pret kuru punktu meeriit peles nobiidi
        }        
    } else WasPushed=false; //ja nav nospiesta poga, pierakstam, ka taa nebija nospiesta
}    
