#ifndef _MODEL_H_
#define _MODEL_H_

#include <stdio.h>
#include "math3d.h"

#include <GL/gl.h>
#include <GL/glu.h>


class CUV //klasse, kur glabaasim katra vertexa UV koordinaates
{
public:
    float U,V;
};


class CModelTriangle //klasse, kur glabaasim katra triistuura virsotnju vertexu indexus
{
public:
    unsigned int Vert[3];    
};


class CModel //klasse, kur glabaasim informaaciju par vienu modeli
{
    unsigned int VertexCount; //cik modelii vertexu
    unsigned int TriangleCount; //cik modelii triistuuru

    Vector3d *Vertex; //poiters uz vertexu masiivu
    CUV *UV; //pointers uz textuuru koordinaatu masiivu
    CModelTriangle *Triangle; //pointers uz triistuuru masiivu
    GLuint DisplayList; //display lists attieciigajam modelim
public:
    CModel();
    ~CModel();
    
    bool LoadFromASCIIFile(char *FileName); //ielaadeejam modeli no ASCII faila
    bool LoadFrom24BitBMPHeightMap(char *FileName); //ielaadeejam modeli no augstuma mapes
    bool CreateDisplayList(); //uztaisam modelja display listu
    bool Delete(); //atbriivojam aiznjemto atminju
    
    bool Draw(); //ziimeejam modeli
    bool DrawImmediateValue(); //ziimeejam ar IMMEDiATE_VALYE
    bool DrawImmediatePointer(); //ziimeejam ar IMMEDIATE_POINTER
    bool DrawVertexArray(); //ziimeejam ar VERTEX_ARRAY
    bool DrawDisplayList(); //ziimeejam ar DISPLAY_LIST
};

#endif
