#include "ogl.h"
#include "scene.h"
#include "text.h"
#include "timer.h"

extern int RenderMode; //mainiigais, kuraa glabaajam info par to, kaadaa veidaa tagad rendereet

extern bool Keys[512]; //glabaajam visu pogu staavokljus

bool ShowHelp=false; //vai ir jaaraada INFO TXT
bool WireFrame=false; //vai ir jaaziimee wireframe?



bool InitOpenGL(int Width,int Height) //inicializeejam dazus opengl mainiigos
{
    glViewport(0,0,Width,Height); //atveelam visu logu OpenGL viewportam
    glShadeModel(GL_SMOOTH); //gludais shading modelis
    glClearColor(0.0f,0.0f,0.0f,0.0f); //melna ekraana notiiriishanas kraasa
    glClearDepth(1.0f); //Z bufferi notiiram uz maksimaalo iespeejamo veertiibu
	glEnable(GL_DEPTH_TEST); //iezleedzam Z buffera testu
	glDepthFunc(GL_LEQUAL); //z buffer atestu noraadam kaa "mazaaks/vienaads"
	glEnable(GL_TEXTURE_2D); //iesleedzam 2d textuuras
	glHint(GL_FOG_HINT, GL_NICEST); //pieprasam jaukaako iespeejamo miglu :)
    return true;
}



bool DrawScene() //ziimeejam visu sceenu
{
    glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); //notiiram ekraana kraasu un Z bufferi
    
    if(Keys[SDLK_w]) //ja nospiesta W poga
    {
        if(WireFrame) //ja ziimeejam wireframe
            WireFrame=false; //beidzam ziimeet wire frame
        else //ja neziimeejam wireframe
            WireFrame=true;//saakam ziimeet wireframe
        Keys[SDLK_w]=false;//atziimeejam pogu kaa nenospiestu, lai shis kods tiku izpildiitstikai
                        //vienreiz uz pogas spiedienu
    }    
    
    if(WireFrame) //ja ziimeejam wireframe
        glPolygonMode(GL_FRONT_AND_BACK,GL_LINE); //iesleedzam wireframe modi
    else //ja nee
        glPolygonMode(GL_FRONT_AND_BACK,GL_FILL); //iesleedzam pildiito modi
    
    if(!Scene.Draw()) //ziimeejam sceenu
        return false;
    
    glPolygonMode(GL_FRONT_AND_BACK,GL_FILL);//iesleedzam pildiito modi,
        //lai texts buutu redzams arii wireframe modee
    
    
    if(!RenderText()) //uzrakstam nepiecieshamo textu uz ekraana
        return false;
        
    return true;     
}


bool RenderHelpTxt() //uzrakstam info par to, kaa kontroleet demo un kaa tas pashlaik renderee
{
    switch(RenderMode)
    {
        case IMMEDIATE_VALUE:
            {
                LVFont.Write("Render Mode: IMMEDIATE_VALUE",
                    0.0f,0.0f,12.0f,20.0f,ALIGN_MIN,ALIGN_MIN);
                break;
            }  
        case IMMEDIATE_POINTER:
            {
                LVFont.Write("Render Mode: IMMEDIATE_POINTER",
                    0.0f,0.0f,12.0f,20.0f,ALIGN_MIN,ALIGN_MIN);
                break;
            }
        case VERTEX_ARRAY:
            {
                LVFont.Write("Render Mode: VERTEX_ARRAY",
                    0.0f,0.0f,12.0f,20.0f,ALIGN_MIN,ALIGN_MIN);
                break;
            }
        case DISPLAY_LIST:
            {
                LVFont.Write("Render Mode: DISPLAY_LIST",
                    0.0f,0.0f,12.0f,20.0f,ALIGN_MIN,ALIGN_MIN);
                break;
            }   
    }
    
    LVFont.Write("Spied 1-4, lai maintu render modi",
    0.0f,20.0f,12.0f,20.0f,ALIGN_MIN,ALIGN_MIN);
    LVFont.Write("W - ieslgt/izslgt wireframe",
    0.0f,40.0f,12.0f,20.0f,ALIGN_MIN,ALIGN_MIN);
    LVFont.Write("Bultias - kustint kameru",
    0.0f,60.0f,12.0f,20.0f,ALIGN_MIN,ALIGN_MIN);
    LVFont.Write("Kreis peles poga + peles kustba - rott kameru",
    0.0f,80.0f,12.0f,20.0f,ALIGN_MIN,ALIGN_MIN); 
    LVFont.Write("ESC - iziet",
    0.0f,100.0f,12.0f,20.0f,ALIGN_MIN,ALIGN_MIN);    
}    



bool RenderText() //urzakstam visu vajadziigo textu uz ekraana
{
    glMatrixMode(GL_PROJECTION); //panjemam projekcijas matricu
    glLoadIdentity(); //resetojam to
    glOrtho(0.0f,800.0f,600.0f,0.0f,0.0f,1.0f);//iesleedzam to otografiskajaa modee
    glMatrixMode(GL_MODELVIEW); //panjemam modelja matricu
    glLoadIdentity(); //resetojam to, lai mees redzeetu tieshi to apgabalu, ko noraadiijaam
                      //ar glOrtho 
    
    glEnable(GL_BLEND); //iesleedzam blendingu, lai teksta backgrounds kljuutu caurspiidiigs
    glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA); //iesleedzam blendinga modi, kur
                                    //ienaakoshaa pikselja alpha nosaka taa caurspiidiigumu
    LVFont.BindTexture(); //piebaindojam fonta textuuru
    
    if(ShowHelp) //ja ir jaaziimee info txt
    {
        RenderHelpTxt(); //ziimeejam info txt
    }
    else LVFont.Write("Nospied F1 ieslgtu/izslgtu info txt",// ja nee, uzrakstam, ka
    0.0f,0.0f,12.0f,20.0f,ALIGN_MIN,ALIGN_MIN); //nospiezot F1 mees paraadiisim info txt
    
    if(Keys[SDLK_F1]) //ja ir nospiests F1
    {
        if(ShowHelp) ShowHelp=false;
            else ShowHelp=true;
        Keys[SDLK_F1]=false;
    }    
    
    
    unsigned Fps=Timer.GetFps(); //ieguustam to, cik kadrus mees norendereejaam pagaajushaa
    char txt[64];                //sekundee, un, cik milisekundes mees rendereejam vienu kadru, videeji
    sprintf(txt,"Fps: %d (%.2fms/f)",Fps,1000.0f/((float)Fps));//uzrakstam to visu uz ekraana
    LVFont.Write(txt,800.0f,0.0f,12.0f,20.0f,ALIGN_MAX,ALIGN_MIN);    
    
    glDisable(GL_BLEND);//izsleedzam blendingu, kad tas vairs nav vajadziigs
    
    return true;
}    
